#ifndef _IMGCLUSTER_H
#define _IMGCLUSTER_H

#include <IMGPrerequisites.h>
#include <IMGBBox.h>
#include <IMGBox2d.h>
#include <IMGPlane3.h>
#include <IMGCluster2d.h>

namespace IMG 
{

class _IMGExport Cluster 
{
  public:
    Cluster();

    virtual ~Cluster();

    Cluster & operator =(const Cluster & p);

    Cluster(const Cluster & p);

	void setNormal(Ogre::Vector3* n);

	Ogre::Vector3* getNormal();

    BBox* getBound();

    Box2d* getBspNodeBound();

    void setBspNodeBound(Box2d* box);

    void print();

    //* return the dominant normal axis, for calculate the 2d projection
    int axisProjected();

    int getId() const;

    void setId(int id_);

	std::vector<Ogre::Vector3>* getVector3sVector();

	Ogre::Vector3* getVector3sTex() const;

    void finish();

	void setPlane(Ogre::Vector3* normal, Ogre::Vector3 * point);

    Plane3 * getPlane();

    //* Return the increment in U (lumel increment in x). For patchs calculation 
	Ogre::Vector3 getIncU();

    //* Return the increment in V (lumel increment in x). For patchs calculation 
	Ogre::Vector3 getIncV();

    //* Return the origin. For patchs calculation 
	Ogre::Vector3 getOrigin();

	bool pointIn(Ogre::Vector3 & point);

	Ogre::Real *pointeru[4]; 

	Ogre::Real *pointerv[4]; 

	Ogre::Vector2 *uv;

  private:
    BBox bound;

    Box2d bspnodebound;

    static unsigned int ID_CLUSTER;

	Ogre::Vector3 normal;

    unsigned int id;

	std::vector<Ogre::Vector3> Vector3s_vector;

	Ogre::Vector3 *Vector3s;

	Ogre::Vector3 *Vector3s_triangle_text;

    int axisproj;

    int order;

    Cluster2d * triangle2d_text;

	Ogre::Vector3 lumel_origin, lumel_x_axis, lumel_y_axis;
	
    Plane3 plane;

};

}
#endif
